/*
 * The Flitter Units File
 * -------------------------------------------------------------
 * Flitter uses a unit-chain style initialization system. This means that
 * individual components of Flitter and its add-ons are specified in order
 * here. Then, when the app is created, Flitter creates a single functional
 * chain by passing the next unit to the current unit's loading script. This
 * launches Flitter with a single function call (FlitterApp.up()) and enables
 * developers to contextualize Flitter within async or callback functions.
 */
const FlitterUnits = {
    'Canon'         : require('libflitter/canon/CanonicalAccessUnit'),
    'Services'      : require('libflitter/services/ServicesUnit'),
    'Config'        : require('libflitter/config/ConfigUnit'),
    'Utility'       : require('libflitter/utility/UtilityUnit'),
    'Database'      : require('libflitter/database/DatabaseUnit'),
    'Models'        : require('libflitter/database/DatabaseModelsUnit'),
    'Upload'        : require('flitter-upload/UploadUnit'),
    'Cli'           : require('flitter-cli/CliUnit'),
    'App'           : require('./app/ServerUnit'),
}

module.exports = exports = FlitterUnits
